package simplemessageconsumer;

import javax.ejb.ActivationConfigProperty;
import javax.ejb.MessageDriven;

import javax.jms.*;

import java.util.logging.*;

/**
 * Message-Driven Bean implementation class for: SimpleMessageConsumer
 *
 */
@MessageDriven(
		activationConfig = { @ActivationConfigProperty(
				propertyName = "destinationType", propertyValue = "javax.jms.Queue"
		) }, 
		mappedName = "jms/MyQueue")
public class SimpleMessageConsumer implements MessageListener {

    /** Default constructor. */
    public SimpleMessageConsumer() {
    }
	
	/**
     * @see MessageListener#onMessage(Message)
     */
    public void onMessage(Message message) {

        Logger logger = Logger.getLogger("SimpleMessageConsumer");

        try {
            if (message instanceof TextMessage) {
            	TextMessage msg = (TextMessage) message;
                logger.info("SimpleMessageConsumer: Message received: " +
                                  msg.getText());
            } else {
                logger.warning("Message of wrong type: " +
                                         message.getClass().getName());
            }
        } catch (Exception e) {
            System.err.println("Exception in SimpleMessageConsumer");
            e.printStackTrace();
        }   
        
    }

}
