/*
 * Main.java
 *
 * Sostanzialmente come l'application client SimpleProducer nel contesto del workspace jms.
 * 
 * In questo caso, si  preferito evitare l'uso di parametri, per far aviare l'applicazione come:  
 * appclient -client build\SimpleMessageProducer 
 *
 * Il consumatore di messaggi sar un message bean 
 * 
 * @author cabibbo
 */

package simpleproducer;

import javax.jms.*;
import javax.annotation.Resource;

public class Main {

	/* L'iniezione delle dipendenze pu avvenire solo nella main class. */ 
	@Resource(mappedName = "jms/MyQueue")
    private static Queue queue;
    // @Resource(mappedName = "jms/MyTopic")
    // private static Topic topic;
    @Resource(mappedName = "jms/MyConnectionFactory")
    private static ConnectionFactory connectionFactory;

    /** main application */
    public static void main(String[] args) {
    	String producerName = "Simple Producer";
    	Destination destination = queue; 
        int numMsgs = 25;
        int delay = 250;

        /* programma principale */ 
        
        /* crea un producer */
        SimpleProducer simpleProducer = new SimpleProducer(producerName, destination, connectionFactory);
        System.out.println("Creato producer: " + simpleProducer.toString());
        
    	/* usa il produttore per inviare n messaggi */ 
        simpleProducer.connect(); 
        for (int i=0; i<numMsgs; i++) {
        	simpleProducer.sendMessage("Message #" + i + " from producer " + producerName); 
        	delay(delay); 
        }
    	simpleProducer.disconnect(); 
        
    }

    private static void delay(int delay) {
        try {
            Thread.sleep(delay);
        } catch (Exception e) {}
    }

}
